import { RegexSequence, RegexFlags } from './types.js';
import './encoder/types.js';

/**
 * Generate RegExp object from elements with optional flags.
 *
 * @param elements Single regex element or array of elements
 * @param flags RegExp flags object
 * @returns RegExp object
 */
declare function buildRegExp(sequence: RegexSequence, flags?: RegexFlags): RegExp;
/**
 * Generate regex pattern from elements.
 * @param elements Single regex element or array of elements
 * @returns regex pattern string
 */
declare function buildPattern(sequence: RegexSequence): string;

export { buildPattern, buildRegExp };
