"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var builders_exports = {};
__export(builders_exports, {
  buildPattern: () => buildPattern,
  buildRegExp: () => buildRegExp
});
module.exports = __toCommonJS(builders_exports);
var import_encoder = require("./encoder/encoder");
var import_elements = require("./utils/elements");
function buildRegExp(sequence, flags) {
  const pattern = (0, import_encoder.encodeSequence)((0, import_elements.ensureArray)(sequence)).pattern;
  const flagsString = encodeFlags(flags ?? {});
  return new RegExp(pattern, flagsString);
}
function buildPattern(sequence) {
  return (0, import_encoder.encodeSequence)((0, import_elements.ensureArray)(sequence)).pattern;
}
function encodeFlags(flags) {
  let result = "";
  if (flags.global)
    result += "g";
  if (flags.ignoreCase)
    result += "i";
  if (flags.multiline)
    result += "m";
  if (flags.hasIndices)
    result += "d";
  if (flags.dotAll)
    result += "s";
  if (flags.sticky)
    result += "y";
  return result;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  buildPattern,
  buildRegExp
});
//# sourceMappingURL=builders.js.map