import { encodeSequence } from "./encoder/encoder";
import { ensureArray } from "./utils/elements";
function buildRegExp(sequence, flags) {
  const pattern = encodeSequence(ensureArray(sequence)).pattern;
  const flagsString = encodeFlags(flags ?? {});
  return new RegExp(pattern, flagsString);
}
function buildPattern(sequence) {
  return encodeSequence(ensureArray(sequence)).pattern;
}
function encodeFlags(flags) {
  let result = "";
  if (flags.global)
    result += "g";
  if (flags.ignoreCase)
    result += "i";
  if (flags.multiline)
    result += "m";
  if (flags.hasIndices)
    result += "d";
  if (flags.dotAll)
    result += "s";
  if (flags.sticky)
    result += "y";
  return result;
}
export {
  buildPattern,
  buildRegExp
};
//# sourceMappingURL=builders.mjs.map