import { RegexConstruct } from '../types.js';
import '../encoder/types.js';

interface Anchor extends RegexConstruct {
    type: 'anchor';
    symbol: string;
}
declare const startOfString: Anchor;
declare const endOfString: Anchor;
declare const wordBoundary: Anchor;
declare const nonWordBoundary: Anchor;
/**
 * @deprecated Renamed to `nonWordBoundary`.
 */
declare const notWordBoundary: Anchor;

export { type Anchor, endOfString, nonWordBoundary, notWordBoundary, startOfString, wordBoundary };
