"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var capture_exports = {};
__export(capture_exports, {
  capture: () => capture,
  ref: () => ref
});
module.exports = __toCommonJS(capture_exports);
var import_encoder = require("../encoder/encoder");
var import_elements = require("../utils/elements");
function capture(sequence, options) {
  return {
    type: "capture",
    children: (0, import_elements.ensureArray)(sequence),
    options,
    encode: encodeCapture
  };
}
function ref(name) {
  return {
    type: "reference",
    name,
    encode: encodeReference
  };
}
function encodeCapture() {
  const name = this.options?.name;
  if (name) {
    return {
      precedence: "atom",
      pattern: `(?<${name}>${(0, import_encoder.encodeSequence)(this.children).pattern})`
    };
  }
  return {
    precedence: "atom",
    pattern: `(${(0, import_encoder.encodeSequence)(this.children).pattern})`
  };
}
function encodeReference() {
  return {
    precedence: "atom",
    pattern: `\\k<${this.name}>`
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  capture,
  ref
});
//# sourceMappingURL=capture.js.map