"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var choice_of_exports = {};
__export(choice_of_exports, {
  choiceOf: () => choiceOf
});
module.exports = __toCommonJS(choice_of_exports);
var import_encoder = require("../encoder/encoder");
var import_elements = require("../utils/elements");
function choiceOf(...alternatives) {
  if (alternatives.length === 0) {
    throw new Error("`choiceOf` should receive at least one alternative");
  }
  return {
    type: "choiceOf",
    alternatives: alternatives.map((c) => (0, import_elements.ensureArray)(c)),
    encode: encodeChoiceOf
  };
}
function encodeChoiceOf() {
  const encodedAlternatives = this.alternatives.map((c) => (0, import_encoder.encodeSequence)(c));
  if (encodedAlternatives.length === 1) {
    return encodedAlternatives[0];
  }
  return {
    precedence: "disjunction",
    pattern: encodedAlternatives.map((n) => n.pattern).join("|")
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  choiceOf
});
//# sourceMappingURL=choice-of.js.map