import { encodeSequence } from "../encoder/encoder";
import { ensureArray } from "../utils/elements";
function choiceOf(...alternatives) {
  if (alternatives.length === 0) {
    throw new Error("`choiceOf` should receive at least one alternative");
  }
  return {
    type: "choiceOf",
    alternatives: alternatives.map((c) => ensureArray(c)),
    encode: encodeChoiceOf
  };
}
function encodeChoiceOf() {
  const encodedAlternatives = this.alternatives.map((c) => encodeSequence(c));
  if (encodedAlternatives.length === 1) {
    return encodedAlternatives[0];
  }
  return {
    precedence: "disjunction",
    pattern: encodedAlternatives.map((n) => n.pattern).join("|")
  };
}
export {
  choiceOf
};
//# sourceMappingURL=choice-of.mjs.map