import { encodeSequence } from "../encoder/encoder";
import { ensureArray } from "../utils/elements";
function negativeLookahead(sequence) {
  return {
    type: "negativeLookahead",
    children: ensureArray(sequence),
    encode: encodeNegativeLookahead
  };
}
function encodeNegativeLookahead() {
  return {
    precedence: "atom",
    pattern: `(?!${encodeSequence(this.children).pattern})`
  };
}
export {
  negativeLookahead
};
//# sourceMappingURL=negative-lookahead.mjs.map