import { RegexConstruct, RegexElement, RegexSequence } from '../types.mjs';
import '../encoder/types.mjs';

interface QuantifierOptions {
    greedy?: boolean;
}
interface ZeroOrMore extends RegexConstruct {
    type: 'zeroOrMore';
    children: RegexElement[];
    options?: QuantifierOptions;
}
interface OneOrMore extends RegexConstruct {
    type: 'oneOrMore';
    children: RegexElement[];
    options?: QuantifierOptions;
}
interface Optional extends RegexConstruct {
    type: 'optional';
    children: RegexElement[];
    options?: QuantifierOptions;
}
declare function zeroOrMore(sequence: RegexSequence, options?: QuantifierOptions): ZeroOrMore;
declare function oneOrMore(sequence: RegexSequence, options?: QuantifierOptions): OneOrMore;
declare function optional(sequence: RegexSequence, options?: QuantifierOptions): Optional;

export { type OneOrMore, type Optional, type QuantifierOptions, type ZeroOrMore, oneOrMore, optional, zeroOrMore };
