"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var quantifiers_exports = {};
__export(quantifiers_exports, {
  oneOrMore: () => oneOrMore,
  optional: () => optional,
  zeroOrMore: () => zeroOrMore
});
module.exports = __toCommonJS(quantifiers_exports);
var import_encoder = require("../encoder/encoder");
var import_elements = require("../utils/elements");
function zeroOrMore(sequence, options) {
  return {
    type: "zeroOrMore",
    children: (0, import_elements.ensureArray)(sequence),
    options,
    encode: encodeZeroOrMore
  };
}
function oneOrMore(sequence, options) {
  return {
    type: "oneOrMore",
    children: (0, import_elements.ensureArray)(sequence),
    options,
    encode: encodeOneOrMore
  };
}
function optional(sequence, options) {
  return {
    type: "optional",
    children: (0, import_elements.ensureArray)(sequence),
    options,
    encode: encodeOptional
  };
}
function encodeZeroOrMore() {
  return {
    precedence: "sequence",
    pattern: `${(0, import_encoder.encodeAtom)(this.children).pattern}*${this.options?.greedy === false ? "?" : ""}`
  };
}
function encodeOneOrMore() {
  return {
    precedence: "sequence",
    pattern: `${(0, import_encoder.encodeAtom)(this.children).pattern}+${this.options?.greedy === false ? "?" : ""}`
  };
}
function encodeOptional() {
  return {
    precedence: "sequence",
    pattern: `${(0, import_encoder.encodeAtom)(this.children).pattern}?${this.options?.greedy === false ? "?" : ""}`
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  oneOrMore,
  optional,
  zeroOrMore
});
//# sourceMappingURL=quantifiers.js.map