import { encodeAtom } from "../encoder/encoder";
import { ensureArray } from "../utils/elements";
function zeroOrMore(sequence, options) {
  return {
    type: "zeroOrMore",
    children: ensureArray(sequence),
    options,
    encode: encodeZeroOrMore
  };
}
function oneOrMore(sequence, options) {
  return {
    type: "oneOrMore",
    children: ensureArray(sequence),
    options,
    encode: encodeOneOrMore
  };
}
function optional(sequence, options) {
  return {
    type: "optional",
    children: ensureArray(sequence),
    options,
    encode: encodeOptional
  };
}
function encodeZeroOrMore() {
  return {
    precedence: "sequence",
    pattern: `${encodeAtom(this.children).pattern}*${this.options?.greedy === false ? "?" : ""}`
  };
}
function encodeOneOrMore() {
  return {
    precedence: "sequence",
    pattern: `${encodeAtom(this.children).pattern}+${this.options?.greedy === false ? "?" : ""}`
  };
}
function encodeOptional() {
  return {
    precedence: "sequence",
    pattern: `${encodeAtom(this.children).pattern}?${this.options?.greedy === false ? "?" : ""}`
  };
}
export {
  oneOrMore,
  optional,
  zeroOrMore
};
//# sourceMappingURL=quantifiers.mjs.map