import { RegexConstruct, RegexElement, RegexSequence } from '../types.js';
import '../encoder/types.js';

interface Repeat extends RegexConstruct {
    type: 'repeat';
    children: RegexElement[];
    options: RepeatOptions;
}
type RepeatOptions = number | {
    min: number;
    max?: number;
    greedy?: boolean;
};
declare function repeat(sequence: RegexSequence, options: RepeatOptions): Repeat;

export { type Repeat, type RepeatOptions, repeat };
