"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var repeat_exports = {};
__export(repeat_exports, {
  repeat: () => repeat
});
module.exports = __toCommonJS(repeat_exports);
var import_encoder = require("../encoder/encoder");
var import_elements = require("../utils/elements");
function repeat(sequence, options) {
  const children = (0, import_elements.ensureArray)(sequence);
  if (children.length === 0) {
    throw new Error("`repeat` should receive at least one element");
  }
  return {
    type: "repeat",
    children,
    options,
    encode: encodeRepeat
  };
}
function encodeRepeat() {
  const atomicNodes = (0, import_encoder.encodeAtom)(this.children);
  if (typeof this.options === "number") {
    return {
      precedence: "sequence",
      pattern: `${atomicNodes.pattern}{${this.options}}`
    };
  }
  return {
    precedence: "sequence",
    pattern: `${atomicNodes.pattern}{${this.options.min},${this.options?.max ?? ""}}${this.options.greedy === false ? "?" : ""}`
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  repeat
});
//# sourceMappingURL=repeat.js.map