import { encodeAtom } from "../encoder/encoder";
import { ensureArray } from "../utils/elements";
function repeat(sequence, options) {
  const children = ensureArray(sequence);
  if (children.length === 0) {
    throw new Error("`repeat` should receive at least one element");
  }
  return {
    type: "repeat",
    children,
    options,
    encode: encodeRepeat
  };
}
function encodeRepeat() {
  const atomicNodes = encodeAtom(this.children);
  if (typeof this.options === "number") {
    return {
      precedence: "sequence",
      pattern: `${atomicNodes.pattern}{${this.options}}`
    };
  }
  return {
    precedence: "sequence",
    pattern: `${atomicNodes.pattern}{${this.options.min},${this.options?.max ?? ""}}${this.options.greedy === false ? "?" : ""}`
  };
}
export {
  repeat
};
//# sourceMappingURL=repeat.mjs.map