"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var hex_color_exports = {};
__export(hex_color_exports, {
  hexColorFinder: () => hexColorFinder,
  hexColorValidator: () => hexColorValidator
});
module.exports = __toCommonJS(hex_color_exports);
var import_builders = require("../builders");
var import_anchors = require("../constructs/anchors");
var import_character_class = require("../constructs/character-class");
var import_choice_of = require("../constructs/choice-of");
var import_repeat = require("../constructs/repeat");
const hexDigit = (0, import_character_class.charClass)(import_character_class.digit, (0, import_character_class.charRange)("a", "f"));
const hexColorFinder = (0, import_builders.buildRegExp)(
  [
    "#",
    (0, import_choice_of.choiceOf)(
      (0, import_repeat.repeat)(hexDigit, 6),
      // #rrggbb
      (0, import_repeat.repeat)(hexDigit, 3)
      // #rgb
    ),
    import_anchors.wordBoundary
  ],
  { ignoreCase: true, global: true }
);
const hexColorValidator = (0, import_builders.buildRegExp)(
  [
    import_anchors.startOfString,
    // Match whole string
    "#",
    (0, import_choice_of.choiceOf)(
      (0, import_repeat.repeat)(hexDigit, 6),
      // #rrggbb
      (0, import_repeat.repeat)(hexDigit, 3)
      // #rgb
    ),
    import_anchors.endOfString
  ],
  { ignoreCase: true }
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  hexColorFinder,
  hexColorValidator
});
//# sourceMappingURL=hex-color.js.map