import { buildRegExp } from "../builders";
import { endOfString, startOfString, wordBoundary } from "../constructs/anchors";
import { charClass, charRange, digit } from "../constructs/character-class";
import { choiceOf } from "../constructs/choice-of";
import { repeat } from "../constructs/repeat";
const hexDigit = charClass(digit, charRange("a", "f"));
const hexColorFinder = buildRegExp(
  [
    "#",
    choiceOf(
      repeat(hexDigit, 6),
      // #rrggbb
      repeat(hexDigit, 3)
      // #rgb
    ),
    wordBoundary
  ],
  { ignoreCase: true, global: true }
);
const hexColorValidator = buildRegExp(
  [
    startOfString,
    // Match whole string
    "#",
    choiceOf(
      repeat(hexDigit, 6),
      // #rrggbb
      repeat(hexDigit, 3)
      // #rgb
    ),
    endOfString
  ],
  { ignoreCase: true }
);
export {
  hexColorFinder,
  hexColorValidator
};
//# sourceMappingURL=hex-color.mjs.map